import { PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class ScsGrade {
  [PrimaryKeyProp]?: 'Id';
  Id!: bigint;
  SchoolId!: bigint;
  Year!: number;
  Name?: string;
  Level!: number;
  Revision!: number;
  CreatedBy?: bigint;
  CreatedTime!: Date;
  UpdatedBy?: bigint;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
  Code?: string;
}

export const ScsGradeSchema = defineEntity({
  class: ScsGrade,
  comment: '届表',
  properties: {
    Id: p.bigint().primary().name('Id').unsigned(false).autoincrement(false).comment('主键Id'),
    SchoolId: p.bigint().name('SchoolId').comment('学校id'),
    Year: p.integer().name('Year').comment('届'),
    Name: p.string().name('Name').length(20).nullable().comment('届名称'),
    Level: p.integer().name('Level').comment('届级别'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
    Code: p.string().name('Code').nullable().comment('届编码(01-99)'),
  },
});
